//Working File 
// 
// spin2cpp --ccode --main Nordic_Demo.spin 
//
#include "FullDuplexSerial.h"
#include <propeller.h>
#include "Nordic.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define waitcnt(n) _waitcnt(n)
#define locknew() _locknew()
#define lockret(i) _lockret(i)
#define lockset(i) _lockset(i)
#define lockclr(i) _lockclr(i)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Min__(int32_t a, int32_t b) { return a < b ? a : b; }
INLINE__ int32_t Max__(int32_t a, int32_t b) { return a > b ? a : b; }
static  int32_t    NordicSpin_Spiread(void);
static  int32_t    NordicSpin_Spiwrite(int32_t Byteout);
static NordicSpin thisobj;
int32_t NordicSpin_Start(int32_t Sck, int32_t Miso, int32_t Mosi, int32_t Csn, int32_t Ce, int32_t Configptr_)
{

  int32_t result = 0;
  result = (SPI_Start(Miso, Mosi, Sck) - 1);
  thisobj.Spisck = Sck;
  thisobj.Spimiso = Miso;
  thisobj.Spimosi = Mosi;
  thisobj.Spicsn = Csn;
  thisobj.Spice = Ce;
  thisobj.Configptr = Configptr_;
  OUTA &= ~(1<<thisobj.Spisck);
  OUTA &= ~(1<<thisobj.Spimosi);
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spice);
  DIRA = ((DIRA & (~(1 << thisobj.Spisck))) | (1 << thisobj.Spisck));
  DIRA = ((DIRA & (~(1 << thisobj.Spimosi))) | (1 << thisobj.Spimosi));
  DIRA = ((DIRA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  DIRA = ((DIRA & (~(1 << thisobj.Spice))) | (1 << thisobj.Spice));
  return result;
}

int32_t NordicSpin_Configure(int32_t Localptr)
{

  int32_t    Localindex;
  thisobj.Configptr = Localptr;
  thisobj.Payloadsize = ((uint8_t *)(thisobj.Configptr + _payloadoffset))[0];
  thisobj.Statusreset = ((uint8_t *)(thisobj.Configptr + _statusoffset))[0];
  thisobj.Globaladdresssize = ((uint8_t *)(thisobj.Configptr + _addresssizeoffset))[0];
  thisobj.Globaladdresssize = (thisobj.Globaladdresssize + 2);
  thisobj.Globaladdresssize = (Min__(thisobj.Globaladdresssize, 5));
  thisobj.Globaladdresssize = (Max__(thisobj.Globaladdresssize, 3));
  {
    int32_t _limit__0001 = (thisobj.Globaladdresssize - 1);
    int32_t _step__0002 = 1;
    Localindex = 0;
    if (Localindex >= _limit__0001) _step__0002 = -_step__0002;
    do {
      thisobj.Rxaddress[Localindex] = ((uint8_t *)((thisobj.Configptr + _rxaddressoffset) + Localindex))[0];
      thisobj.Txaddress[Localindex] = ((uint8_t *)(((thisobj.Configptr + _rxaddressoffset) + thisobj.Globaladdresssize) + Localindex))[0];
      Localindex = (Localindex + _step__0002);
    } while (((_step__0002 > 0) && (Localindex <= _limit__0001)) || ((_step__0002 < 0) && (Localindex >= _limit__0001)));
  }
  OUTA &= ~(1<<thisobj.Spice);
  OUTA &= ~(1<<thisobj.Spicsn);
  
  NordicSpin_Spiwrite((W_register + En_aa));
  NordicSpin_Spiwrite(((uint8_t *)(Localptr + En_aa))[0]);
  
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  
  NordicSpin_Spiwrite((W_register + Setup_retr));
  NordicSpin_Spiwrite(((uint8_t *)(Localptr + Setup_retr))[0]);
  
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  
  NordicSpin_Spiwrite((W_register + Setup_aw));
  NordicSpin_Spiwrite(((uint8_t *)(Localptr + Setup_aw))[0]);
  
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  
  NordicSpin_Spiwrite((W_register + Rf_setup));
  NordicSpin_Spiwrite(((uint8_t *)(Localptr + Rf_setup))[0]);
  
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  
  NordicSpin_Spiwrite((W_register + Rx_pw_p0));
  NordicSpin_Spiwrite(thisobj.Payloadsize);
  
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  
  NordicSpin_Spiwrite((W_register + Rf_ch));
  NordicSpin_Spiwrite(((uint8_t *)(Localptr + Rf_ch))[0]);
  
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite((W_register + Rx_addr_p0));
  {
    int32_t _limit__0003 = (thisobj.Globaladdresssize - 1);
    int32_t _step__0004 = 1;
    Localindex = 0;
    if (Localindex >= _limit__0003) _step__0004 = -_step__0004;
    do {
      NordicSpin_Spiwrite(thisobj.Rxaddress[Localindex]);
      Localindex = (Localindex + _step__0004);
    } while (((_step__0004 > 0) && (Localindex <= _limit__0003)) || ((_step__0004 < 0) && (Localindex >= _limit__0003)));
  }
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite((W_register + Tx_addr));
  {
    int32_t _limit__0005 = (thisobj.Globaladdresssize - 1);
    int32_t _step__0006 = 1;
    Localindex = 0;
    if (Localindex >= _limit__0005) _step__0006 = -_step__0006;
    do {
      NordicSpin_Spiwrite(thisobj.Txaddress[Localindex]);
      Localindex = (Localindex + _step__0006);
    } while (((_step__0006 > 0) && (Localindex <= _limit__0005)) || ((_step__0006 < 0) && (Localindex >= _limit__0005)));
  }
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite((W_register + Config));
  NordicSpin_Spiwrite(((uint8_t *)Localptr)[0]);
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA = ((OUTA & (~(1 << thisobj.Spice))) | (1 << thisobj.Spice));
  
}

int32_t NordicSpin_Spiread(void)
{
  int32_t result = 0;
  result = SPI_Shiftin();
  return result;
}

int32_t NordicSpin_Spiwrite(int32_t Byteout)
{
  waitcnt(((CLKFREQ / 50000 )) + CNT);
  SPI_Shiftout(Byteout);
  return 0;
}

int32_t NordicSpin_Spiwritepub(int32_t Localregister, int32_t Localptr, int32_t Bytestowrite)
{
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite((Localregister + W_register));
  SPI_Shiftoutstr(Localptr, Bytestowrite);
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  return 0;
}

int32_t NordicSpin_Transmitstring(int32_t Localptr)
{
  int32_t    Localindex;
  OUTA &= ~(1<<thisobj.Spice);
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite((W_register + _status));
  NordicSpin_Spiwrite(thisobj.Statusreset);
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite((W_register + Config));
  NordicSpin_Spiwrite((((uint8_t *)thisobj.Configptr)[0] - 1));
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite(Flush_tx);
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite(W_tx_payload);
  SPI_Shiftoutstr(Localptr, thisobj.Payloadsize);
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA = ((OUTA & (~(1 << thisobj.Spice))) | (1 << thisobj.Spice));
  waitcnt((1000 + CNT));
  OUTA &= ~(1<<thisobj.Spice);
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite((W_register + Tx_addr));
  Localindex = 0;
  do {
    NordicSpin_Spiwrite(thisobj.Txaddress[Localindex]);
    Localindex = (Localindex + 1);
  } while (Localindex <= 4);
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA &= ~(1<<thisobj.Spicsn);
  NordicSpin_Spiwrite((W_register + Config));
  NordicSpin_Spiwrite(((uint8_t *)thisobj.Configptr)[0]);
  OUTA = ((OUTA & (~(1 << thisobj.Spicsn))) | (1 << thisobj.Spicsn));
  OUTA = ((OUTA & (~(1 << thisobj.Spice))) | (1 << thisobj.Spice));
  return 0;
}

